#include <stdio.h>
#include <stdlib.h>
#include <string.h>



static char *tbl[] = {
	"\x9d\x89" "dlz",	/* {('I' + 'T'), ('D' + 'E'), 'd', 'l', 'z'}, */
	"\x9d\x89" "ike",	/* {('I' + 'T'), ('D' + 'E'), 'i', 'k', 'e'}, */
	"*Pola",
	"TTz",
	NULL,
};


static unsigned int get_word(unsigned char *p){
	return (p[0] | (p[1] << 8));
}


static int check(unsigned char *buf, long size){
	long t;

	t = buf[0];
	t = (((t & 0x0f) << 8) | get_word(buf + 1));
	if((t + 8) != size){
		return 0;
	}

	t = buf[5];
	if(0 != (t & 3)){
		return 0;
	}
	t = ((t << 6) | get_word(buf + 6));
	if(t < size){
		return 0;
	}

	return 1;
}



int main(int argc, char *argv[]){
	FILE *fp;
	char buf[8];
	int k;

	if(2 > argc){
		exit(0);
	}

	fp = fopen(argv[1], "rb+");
	if(NULL == fp){
		printf("%s ݂͑܂\n", argv[1]);
		exit(1);
	}
	fread(buf, 1, 8, fp);

	for(k = 0; NULL != tbl[k]; ++k){
		if(0 == memcmp(buf, tbl[k], 5)){
			break;
		}
	}

	if(0 == k){
		printf("%s ͐ DIET ł\n", argv[1]);
		fclose(fp);
		exit(0);
	}

	if(NULL == tbl[k]){
		long size;
		char *buf2;

		fseek(fp, 0, SEEK_END);
		size = ftell(fp);
		if(0 == check(buf, size)){
			fclose(fp);
			printf("%s  DIET ł͂܂\n", argv[1]);
			exit(0);
		}

		buf2 = (char*)malloc(size);
		if(NULL == buf2){
			fclose(fp);
			printf("mۂł܂ł (%s\n", argv[1]);
			exit(0);
		}
		fseek(fp, 0, SEEK_SET);
		fread(buf2, 1, size, fp);
		fseek(fp, 5, SEEK_SET);
		fwrite(buf2, 1, size, fp);
		free(buf2);
	}

	fseek(fp, 0, SEEK_SET);
	fwrite(tbl[0], 1, 5, fp);
	fclose(fp);

	printf("%s ̃wb_ύX܂\n", argv[1]);

	exit(0);
}
